#line 20 "cam.nw"
#define RETURN(_res) { \
    Label ret_ip = (Label)sp[0]; \
    sp[0] = (_res); \
    GOTO(ret_ip); \
}

#define ENTER(_node) { \
    if ( is_boxed(_node) ) { \
	CHECK_STACK1(); \
	*--sp = (_node); \
	GOTO((_node)->info->eval); \
    } \
    RETURN(_node); \
}

#line 39 "cam.nw"
#define FAIL() GOTO(nondet_handlers->fail)

#line 53 "cam.nw"
#define EVAL_RIGID(what, l) \
for (;;) { \
    switch ( sp[0]->info->kind ) { \
    case INDIR_KIND: sp[0] = sp[0]->n.node; continue; \
    case LAZY_KIND: \
	CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	GOTO(sp[0]->info->eval); \
    case LVAR_KIND: \
	CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	GOTO(sync_var); \
    case what##_KIND: break; \
    default: invalid_arg(#l, sp[0]->info->kind); \
    } \
    break; \
}

#define EVAL_RIGID_CHAR(l)		EVAL_RIGID(CHAR, l)
#define EVAL_RIGID_FLOAT(l)		EVAL_RIGID(FLOAT, l)
#define EVAL_RIGID_PTR(l)		EVAL_RIGID(PTR, l)
#define EVAL_RIGID_FOREIGN_PTR(l)	EVAL_RIGID(FOREIGN_PTR, l)
#define EVAL_RIGID_DATA(l)		EVAL_RIGID(CAPP, l)
#define EVAL_RIGID_PAPP(l)		EVAL_RIGID(PAPP, l)
#define EVAL_RIGID_VECTOR(l)		EVAL_RIGID(VECTOR, l)
#define EVAL_RIGID_ABSTRACT(l)		EVAL_RIGID(ABSTRACT, l)

#define EVAL_RIGID_INT(l) \
for (;;) { \
    if ( is_boxed(sp[0]) ) \
	switch ( sp[0]->info->kind ) { \
	case INDIR_KIND: sp[0] = sp[0]->n.node; continue; \
	case LAZY_KIND: \
	    CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	    GOTO(sp[0]->info->eval); \
	case LVAR_KIND: \
	    CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	    GOTO(sync_var); \
	case INT_KIND: break; \
	default: invalid_arg(#l, sp[0]->info->kind); \
	} \
    break; \
}

#define EVAL_FLEX_POLY(l) \
for (;;) { \
    if ( is_boxed(sp[0]) ) \
	switch ( sp[0]->info->kind ) { \
	case INDIR_KIND: sp[0] = sp[0]->n.node; continue; \
	case LAZY_KIND: \
	    CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	    GOTO(sp[0]->info->eval); \
	default: break; \
	} \
    break; \
}

#define EVAL_RIGID_POLY(l) \
for (;;) { \
    if ( is_boxed(sp[0]) ) \
	switch ( sp[0]->info->kind ) { \
	case INDIR_KIND: sp[0] = sp[0]->n.node; continue; \
	case LAZY_KIND: \
	    CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	    GOTO(sp[0]->info->eval); \
	case LVAR_KIND: \
	    CHECK_STACK1(); sp -= 1; sp[0] = sp[1]; sp[1] = (Node *)(l); \
	    GOTO(sync_var); \
	default: break; \
	} \
    break; \
}
