#line 40 "run.nw"
#if !USE_TRAMPOLINE
# ifndef __GNUC__
#  error "direct jumps require Gnu C; reconfigure with --enable-trampoline"
# endif
#endif

#if USE_TRAMPOLINE
typedef void *(*Label)(void);
#else
typedef void *Label;
#endif

#line 93 "run.nw"
#if USE_TRAMPOLINE

# define FUNCTION(f)		void *f(void)
# define DECLARE_ENTRYPOINT(l)	extern void *l(void)
# define DECLARE_LABEL(l)       static void *l(void)
# define EXPORT_LABEL(l)
# define ENTRY_LABEL(l)

# define GOTO(l)		return (void *)(l)

#else /* !USE_TRAMPOLINE */

# define C_STACK_SIZE 8192

# if __GNUC__ > 3 || __GNUC__ == 3 && __GNUC_MINOR__ >= 1
#  define _USED			__attribute__((used))
#  define _USE(l)
# else
#  define _USED
#  define _USE(l)		: : "g" (_FUNC(l))
# endif

# define FUNCTION(f)		void _FUNC(f)(void)
# define DECLARE_ENTRYPOINT(l)			\
    void _FUNC(l)(void) _USED;			\
    void l(void) __asm__(_ENTRY_LABEL(l))
# define DECLARE_LABEL(l)			\
    static void _FUNC(l)(void) _USED;		\
    void l(void) __asm__(_ENTRY_LABEL(l))
# define _FUNC(f) f##_func
# define EXPORT_LABEL(l)	__asm__(" .globl " _ENTRY_LABEL(l) "\n");
# define ENTRY_LABEL(l)				\
    __asm__(_ENTRY_LABEL(l) ":" _USE(l));	\
    __asm__("" : : "g"(&&entry)); entry:
# define _ENTRY_LABEL(l)	#l "_entry"

# if __GNUC__ == 2 && __GNUC_MINOR__ == 91 && defined(__sparc)
/* work around an instruction scheduler bug in gcc 2.91 for sparc */
extern Label ip;
#  define _GOTO(l)		ip = (Label)(l); goto *ip
# else
#  define _GOTO(l)		goto *(Label)(l)
# endif
# define GOTO(l) ({			      \
	__label__ _l;			      \
	__asm__("" : : "g"(&&_l) : "memory"); \
	_GOTO(l);			      \
    _l: halt();				      \
    })

#endif /* !USE_TRAMPOLINE */

#line 151 "run.nw"
extern void run(Label ip);
extern void halt(void) __attribute__ ((noreturn));

