#line 41 "spaces.nw"
#if 0
typedef struct search_space SearchSpace; /* already declared in heap.h */
#endif
#if !COPY_SEARCH_SPACE
typedef struct script Script;
#endif

struct search_space {
    NodeInfo	*info;
#if !COPY_SEARCH_SPACE
    SearchSpace	*root;		/* pointer to root space */
    SearchSpace	*parent;	/* parent space */
    SearchSpace	*active;	/* active space (valid only on root) */
    Script	*script;	/* saved local bindings */
#endif
};

extern SearchSpace	 *ss;
extern const SearchSpace global_space;

#line 109 "spaces.nw"
#if !COPY_SEARCH_SPACE
# define is_local_space(space) ((space)->root == ss->root)
#else
# define is_local_space(space) ((space) == ss)
#endif

#line 127 "spaces.nw"
#if !COPY_SEARCH_SPACE
typedef struct script_rec {
    word	 *addr;		/* address to be updated */
    word	 inInfo;	/* info vector inside space */
    word	 outInfo;	/* info vector outside space */
    unsigned int ofs;		/* offset within node */
    word	 inVal;		/* value inside space */
    word	 outVal;	/* value outside space */
} ScriptRec;

struct script {
    NodeInfo  *info;
    unsigned  length;
    ScriptRec data[1];
};
#endif

#line 293 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void leave_context(void);
#else
# define leave_context()  /* empty */
#endif

#line 344 "spaces.nw"
extern void new_search_space(void);

#line 373 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern boolean inject_search_space(SearchSpace *);
#else
# define inject_search_space(space)  false
#endif

#line 410 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void save_search_space(void);
#else
# define save_search_space()  /* empty */
#endif

#line 475 "spaces.nw"
extern void discard_search_space(void);

#line 497 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void restore_search_space(SearchSpace *space);
#else
# define restore_search_space(space)  (ss = (space))
#endif

#line 527 "spaces.nw"
extern Node *copy_graph(Node *graph, SearchSpace *space);

