#line 21 "stack.nw"
extern Node **stack_base, **stack_end;
extern Node **sp;

#line 44 "stack.nw"
extern void init_stack(unsigned int stack_size);

#line 69 "stack.nw"
extern void stack_overflow(void) __attribute__ ((noreturn));

#define CHECK_STACK1()	 if ( sp == stack_base ) stack_overflow();
#define CHECK_STACK(n)	 if ( sp - (n) < stack_base ) stack_overflow();

#line 109 "stack.nw"
#define is_search_context(cp)	((cp)->btAlts == 0)

typedef struct choicepoint {
    const Label	       *btAlts;		/* remaining alternatives */
    unsigned int       btCid;		/* id of current thread */
    Node	       **btDsBase;	/* saved thread stack base */
    struct choicepoint *btBp;		/* previous choice point */
    union thread_node  *btRq;		/* saved run queue */
#if !COPY_SEARCH_SPACE
    struct save_rec    *btTp;		/* saved trail pointer */
#endif
    struct dict_node   *btDict;		/* saved dictionary tail pointer */
    word	       *btHp;		/* saved heap pointer */
    SearchSpace	       *btSpc;		/* saved search space */
    const struct nondet_handlers *btHandlers;
} Choicepoint;

extern Choicepoint *bp;

#line 151 "stack.nw"
extern const struct nondet_handlers {
    Label choices;
    Label deadlock;
    Label fail;
} *nondet_handlers;

#line 180 "stack.nw"
typedef struct exception_frame
{
    Node		   *handler;
    struct exception_frame *frame;
} ExceptionFrame;

extern ExceptionFrame *efp;

