#line 22 "trail.nw"
#if !COPY_SEARCH_SPACE
typedef struct save_rec {
    word	 *addr;		/* address of updated node */
    word	 info;		/* old info vector */
    unsigned int ofs;		/* offset within node */
    word	 val;		/* saved value */
} SaveRec;
#endif

#line 40 "trail.nw"
#if !COPY_SEARCH_SPACE
extern SaveRec *trail_base, *trail_end;
extern SaveRec *tp;

extern void trail_overflow(void) __attribute__ ((noreturn));

#define CHECK_TRAIL1()	if ( tp == trail_end ) trail_overflow();
#define CHECK_TRAIL(n)	if ( tp + n > trail_end ) trail_overflow();
#endif

#line 82 "trail.nw"
#if !COPY_SEARCH_SPACE
extern void init_trail(unsigned int trail_size);
#endif

#line 123 "trail.nw"
#if !COPY_SEARCH_SPACE
#define INFO_OFS	word_offsetof(Node, info)

#define DO_SAVE(v,f) do { \
    CHECK_TRAIL1(); \
    tp->addr = (word *)(v); \
    tp->info = tp->addr[INFO_OFS]; \
    tp->ofs  = (word *)&(v->f) - (word *)(v); \
    tp->val  = (word)(v->f); \
    tp++; \
} while (0)
#define SAVE(v,f) do { \
    if ( (word *)(v) < hlim && (word *)(v->f) < hlim ) \
	DO_SAVE(v,f); \
} while (0)
#else
# define DO_SAVE(v,f)  /* empty */
# define SAVE(v,f)     /* empty */
#endif

#line 151 "trail.nw"
#if !COPY_SEARCH_SPACE
#define RESTORE(oldTp) do { \
    while ( tp > oldTp ) { \
	--tp; \
	tp->addr[INFO_OFS] = tp->info; \
	tp->addr[tp->ofs]  = tp->val; \
    } \
} while (0)
#endif
